Subject: hpff-doc: Comments on library.tex and Grade/grade-[up,down].tex

From: Carol Munroe <[email-masked]>
Date: Fri, 18 Oct 96 15:12:57 EDT

---------------------------------------------------------------------------
[email-masked] is a mailing list for HPF 2.0 language specification
authors and editors.  Instructions for adding or deleting yourself from this
list appear at the bottom of this message.
---------------------------------------------------------------------------
**********************************************
One more small correction to file library.tex:

Section 6.5 Generic Intrinsic and Library Procedures, p. 99, line 6, says

	"See Section 13.10 of the standard."

This reference should be updated to 

	"See Section 13.11 of the standard."

******************************************************************
file Grade/grade-up.tex

****
Section 6.7.14, p. 112, lines 20-21 now reads
	\Case (ii):     The result of \newline
       	        {\tt R = LBOUND(ARRAY, DIM=K) + GRADE_UP(ARRAY, DIM=K) -1}

There's nothing wrong with this, but it would emphasize GRADE_UP, the
function being defined, more clearly (and look more like Case (i)) in
a permuted order:

	\Case (ii):     The result of \newline
       	        {\tt R =  GRADE_UP(ARRAY, DIM=K) + LBOUND(ARRAY, DIM=K) -1}

**** Section 6.7.14, p. 112, lines 43-48 currently include an example
showing the result of GRADE_UP(A, DIM=1). It would be useful to include the
result of GRADE_UP(A, DIM=2) as well, partly for symmetry and completeness,
but also because there can be some confusion between what the grade
function returns (for instance, in TMC's CM Fortran, there is a RANK 
function that returns the inverse permutation), and the example shown,
with DIM=1, returns a grade permutation that happens to be equal to its
inverse. The DIM=2 example is distinct from its inverse, however.
I.e., continue the current text, at the bottom of the page, as shown

	then {\tt GRADE_UP(A, DIM = 1)} has the value
                                       \MATRIX{      1,  3,  1              \cr
                                                     3,  2,  2              \cr
                                                     2,  1,  3 },

	and {\tt GRADE_UP(A, DIM = 2)} has the value
                                       \MATRIX{      1,  3,  2              \cr
                                                     3,  1,  2              \cr
                                                     1,  2,  3 }.

******************************************************************
file Grade/grade-down.tex

****
Section 6.7.13, p. 111, lines 6-7 now reads
	\Case (ii):     The result of \newline
       	        {\tt R = LBOUND(ARRAY, DIM=K) + GRADE_DOWN(ARRAY, DIM=K) -1}

To emphasize GRADE_DOWN, the function being defined, more clearly (and look
more like Case (i)) in a permuted order:

	\Case (ii):     The result of \newline
       	        {\tt R = GRADE_DOWN(ARRAY, DIM=K) + LBOUND(ARRAY, DIM=K) -1}

**** Section 6.7.13, p. 111, lines 30-35 currently include an example
showing the result of GRADE_DOWN(A, DIM=1). For consistency with
the GRADE_UP changes, it would be nice to add an example of 
GRADE_DOWN(A, DIM=2) here as well.

I.e., continue the current text as shown

	then {\tt GRADE_DOWN(A, DIM = 1)} has the value
                                       \MATRIX{      2,  1,  3              \cr
                                                     1,  2,  1              \cr
                                                     3,  3,  2 },

	and {\tt GRADE_DOWN(A, DIM = 2)} has the value
                                       \MATRIX{      2,  3,  1              \cr
                                                     2,  1,  3              \cr
                                                     3,  2,  1 }.

---------------------------------------------------------------------------
To (un)subscribe to this list, send mail to [email-masked].
Leave the subject line blank, and in the body put the line
(un)subscribe <email-address>
---------------------------------------------------------------------------